﻿using MySql.Data.MySqlClient;
using System;
using System.IO;
using System.Text.RegularExpressions;

namespace PMCProjekt
{
    internal class Programm
    {
        static void Main(string[] args)
        {
            MySqlConnection myconnection;
            string meineVerbindungszeichenfolge;

            // Kundennummer eingeben
           // Console.Write("Bitte geben Sie die Kundennummer ein (z.B. K2-002): ");
            //string kundennummer = Console.ReadLine();
            meineVerbindungszeichenfolge = "server=localhost;uid=root;pwd=root;database=import_export";

            try
            {
                myconnection = new MySqlConnection(meineVerbindungszeichenfolge);
                myconnection.Open();

                // Datei einlesen
                string dateiPfad = "C:/Schule/PMC/import_yutani.csv";
                if (File.Exists(dateiPfad))
                {
                    using (StreamReader sr = new StreamReader(dateiPfad))
                    {
                        string zeile;
                        while ((zeile = sr.ReadLine()) != null)
                        {
                            // Werte aus der Zeile extrahieren
                            string[] werte = zeile.Split(',');
                            if (werte.Length >= 4)
                            {
                                string anrede = werte[0];
                                string vorname = werte[1];
                                string nachname = werte[2];
                                string geburtsdatum = werte[3];
                                string adresse = werte.Length > 4 ? werte[4] : null;
                                string plz = werte.Length > 5 ? werte[5] : null;
                                string stadt = werte.Length > 6 ? werte[6] : null;
                                string email = werte.Length > 7 ? werte[7] : null;
                                string telefonnummern = werte.Length > 8 ? werte[8] : null;

                                // Daten validieren
                                if (DatenValidieren(anrede, vorname, nachname, geburtsdatum, plz, email, telefonnummern))
                                {
                                    // Nutzer in die Tabelle 'user' einfügen
                                //    string abfrage = "INSERT INTO user (clientId, genderId, firstname, lastname, birthdate, created) VALUES (@clientId, @genderId, @firstname, @lastname, @birthdate, NOW())";
                                //    using (MySqlCommand mycommand = new MySqlCommand(abfrage, myconnection))
                                //    {
                                //        mycommand.Parameters.AddWithValue("@clientId", HoleKundenId(kundennummer));
                                //        mycommand.Parameters.AddWithValue("@genderId", HoleGeschlechtsId(anrede));
                                //        mycommand.Parameters.AddWithValue("@firstname", vorname);
                                //        mycommand.Parameters.AddWithValue("@lastname", nachname);
                                //        mycommand.Parameters.AddWithValue("@birthdate", DateTime.ParseExact(geburtsdatum, "dd.MM.yyyy", null));

                                //        mycommand.ExecuteNonQuery();
                                //    }

                                //    // Adresse in die Tabelle 'address' einfügen
                                //    if (adresse != null || plz != null || stadt != null)
                                //    {
                                //        string adressAbfrage = "INSERT INTO address (userId, street, postalcode, city) VALUES (LAST_INSERT_ID(), @street, @plz, @city)";
                                //        using (MySqlCommand adressBefehl = new MySqlCommand(adressAbfrage, myconnection))
                                //        {
                                //            adressBefehl.Parameters.AddWithValue("@street", adresse);
                                //            adressBefehl.Parameters.AddWithValue("@plz", plz);
                                //            adressBefehl.Parameters.AddWithValue("@city", stadt);

                                //            adressBefehl.ExecuteNonQuery();
                                //        }
                                //    }

                                //    // E-Mail in die Tabelle 'email' einfügen
                                //    if (email != null)
                                //    {
                                //        string emailAbfrage = "INSERT INTO email (userId, email) VALUES (LAST_INSERT_ID(), @Email)";
                                //        using (MySqlCommand emailBefehl = new MySqlCommand(emailAbfrage, myconnection))
                                //        {
                                //            emailBefehl.Parameters.AddWithValue("@Email", email);
                                //            emailBefehl.ExecuteNonQuery();
                                //        }
                                //    }

                                //    // Telefonnummern in die Tabelle 'phone' einfügen
                                //    if (telefonnummern != null)
                                //    {
                                //        string[] telefonNummern = telefonnummern.Split(';');
                                //        foreach (var telefon in telefonNummern)
                                //        {
                                //            string[] telefonTeile = telefon.Split(' ');
                                //            if (telefonTeile.Length == 2)
                                //            {
                                //                string telefonAbfrage = "INSERT INTO phone (userId, phoneprefix, phonenumber) VALUES (LAST_INSERT_ID(), @phoneprefix, @phonenumber)";
                                //                using (MySqlCommand telefonBefehl = new MySqlCommand(telefonAbfrage, myconnection))
                                //                {
                                //                    telefonBefehl.Parameters.AddWithValue("@phoneprefix", telefonTeile[0]);
                                //                    telefonBefehl.Parameters.AddWithValue("@phonenumber", telefonTeile[1]);

                                //                    telefonBefehl.ExecuteNonQuery();
                                //                }
                                //            }
                                //        }
                                //    }
                                }
                                else
                                {
                                    // Ungültige Daten protokollieren
                                    ProtokolliereUngueltigeDaten(werte);
                                }
                            }
                        }
                    }
                }
                else
                {
                    Console.WriteLine("Datei nicht gefunden.");
                }

                myconnection.Close();
            }
            catch (MySqlException ex)
            {
                Console.WriteLine("Fehler: " + ex.Message);
            }
        }

        // Kunden-ID basierend auf der Kundennummer ermitteln
        static int HoleKundenId(string kundennummer)
        {
            // Kunden-ID zurückgeben basierend auf der Kundennummer
            return 1; // Logik hier ersetzen
        }

        // Geschlechts-ID basierend auf der Anrede ermitteln
        static int HoleGeschlechtsId(string anrede)
        {
            if (anrede.ToLower() == "herr") return 1;
            if (anrede.ToLower() == "frau") return 2;
            if (anrede.ToLower() == "divers") return 3;
            return 0; // Unbekannt oder nicht angegeben
        }

        // Daten validieren
        static bool DatenValidieren(string anrede, string vorname, string nachname, string geburtsdatum, string plz, string email, string telefonnummern)
        {
            bool istGueltig = true;

            // Geburtsdatum validieren
            DateTime parsedDate;
            if (!DateTime.TryParseExact(geburtsdatum, "dd.MM.yyyy", null, System.Globalization.DateTimeStyles.None, out parsedDate))
            {
                istGueltig = false;
            }

            // E-Mail-Adresse validieren
            if (!string.IsNullOrEmpty(email))
            {
                Regex emailRegex = new Regex(@"^[^@\s]+@[^@\s]+\.[^@\s]+$");
                if (!emailRegex.IsMatch(email))
                {
                    istGueltig = false;
                }
            }

            // Postleitzahl validieren
            if (!string.IsNullOrEmpty(plz))
            {
                if (plz.Length != 5 || !int.TryParse(plz, out _))
                {
                    istGueltig = false;
                }
            }

            // Telefonnummern validieren
            if (!string.IsNullOrEmpty(telefonnummern))
            {
                string[] telefonNummern = telefonnummern.Split(';');
                foreach (var telefon in telefonNummern)
                {
                    string[] telefonTeile = telefon.Split(' ');
                    if (telefonTeile.Length != 2 ||
                        telefonTeile[0].Length < 3 || telefonTeile[0].Length > 5 ||
                        telefonTeile[1].Length < 4 || telefonTeile[1].Length > 10 ||
                        !int.TryParse(telefonTeile[0], out _) || !int.TryParse(telefonTeile[1], out _))
                    {
                        istGueltig = false;
                    }
                }
            }

            return istGueltig;
        }

        // Ungültige Daten protokollieren
        static void ProtokolliereUngueltigeDaten(string[] daten)
        {
            string protokollPfad = "C:/Schule/PMC/ungueltige_Daten.txt";
            using (StreamWriter sw = new StreamWriter(protokollPfad, true))
            {
                sw.WriteLine(string.Join(",", daten));
            }
        }
    }
}
